-- cache settings
CREATE TABLE `Cache_Settings` (`ID` int(11) unsigned NOT NULL auto_increment, `Catalogue_ID` int(11) unsigned NOT NULL default '0', `Audit_Begin` datetime NOT NULL default '0000-00-00 00:00:00', `Audit_Time` smallint(6) unsigned NOT NULL default '0', `Status_list` tinyint(4) unsigned NOT NULL default '0', `Quota_list` int(11) unsigned NOT NULL default '0', `Overdraft_list` tinyint(4) unsigned NOT NULL default '0', `Status_full` tinyint(4) unsigned NOT NULL default '0', `Quota_full` int(11) unsigned NOT NULL default '0', `Overdraft_full` tinyint(4) unsigned NOT NULL default '0', `Status_browse` tinyint(4) unsigned NOT NULL default '0', `Quota_browse` int(11) unsigned NOT NULL default '0', `Overdraft_browse` tinyint(4) unsigned NOT NULL default '0', `Status_calendar` tinyint(4) unsigned NOT NULL default '0', `Quota_calendar` int(11) unsigned NOT NULL default '0', `Overdraft_calendar` tinyint(4) unsigned NOT NULL default '0', `Status_function` tinyint(4) unsigned NOT NULL default '0', `Quota_function` int(11) unsigned NOT NULL default '0', `Overdraft_function` tinyint(4) unsigned NOT NULL default '0', PRIMARY KEY  (`ID`), UNIQUE KEY `Catalogue_ID` (`Catalogue_ID`) ) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
-- cache audit
CREATE TABLE `Cache_Audit` (`ID` int(11) unsigned NOT NULL auto_increment, `Catalogue_ID` int(11) unsigned NOT NULL default '0', `Subdivision_ID` int(11) unsigned NOT NULL default '0', `Sub_Class_ID` int(11) unsigned NOT NULL default '0', `Class_ID` int(11) unsigned NOT NULL default '0', `Message_ID` int(11) unsigned NOT NULL default '0', `Essence` varchar(16) NOT NULL default '', `Query_String` varchar(255) NOT NULL default '', `Unique_String` varchar(32) NOT NULL default '', `Attempt_Write` int(11) unsigned NOT NULL default '0', `Attempt_Read` int(11) unsigned NOT NULL default '0', `Writed` int(11) unsigned NOT NULL default '0', `Readed` int(11) unsigned NOT NULL default '0', PRIMARY KEY  (`ID`) ) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
-- cache clear
CREATE TABLE `Cache_Clear` (`ID` int(11) unsigned NOT NULL auto_increment, `Catalogue_ID` int(11) unsigned NOT NULL default '0', `Subdivision_ID` int(11) unsigned NOT NULL default '0', `Sub_Class_ID` int(11) unsigned NOT NULL default '0', `Class_ID` int(11) unsigned NOT NULL default '0', `Message_ID` int(11) unsigned NOT NULL default '0', `Essence` varchar(16) NOT NULL default '', `Efficiency` float unsigned NOT NULL default '0', PRIMARY KEY  (`ID`) ) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
-- default values in `Cache_Settings`
INSERT INTO `Cache_Settings` (`ID`, `Catalogue_ID`, `Audit_Begin`, `Audit_Time`, `Status_list`, `Quota_list`, `Overdraft_list`, `Status_full`, `Quota_full`, `Overdraft_full`, `Status_browse`, `Quota_browse`, `Overdraft_browse`, `Status_calendar`, `Quota_calendar`, `Overdraft_calendar`, `Status_function`, `Quota_function`, `Overdraft_function`) VALUES (1, 1, '0000-00-00 00:00:00', 24, 1, 5, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1);
-- add new columns in tables
ALTER TABLE `Catalogue` ADD COLUMN `Cache_Access_ID` int(11) unsigned NOT NULL default '2';
ALTER TABLE `Subdivision` ADD COLUMN `Cache_Access_ID` int(11) unsigned NOT NULL default '0';
ALTER TABLE `Sub_Class` ADD COLUMN `Cache_Access_ID` int(11) unsigned NOT NULL default '0';
ALTER TABLE `Catalogue` ADD COLUMN `Cache_Lifetime` int(11) unsigned NOT NULL default '60';
ALTER TABLE `Subdivision` ADD COLUMN `Cache_Lifetime` int(11) unsigned NOT NULL default '0';
ALTER TABLE `Sub_Class` ADD COLUMN `Cache_Lifetime` int(11) unsigned NOT NULL default '0';
-- append module info
INSERT INTO `Module` (`Module_Name`, `Keyword`, `Description`, `Parameters`, `Example_URL`, `Help_URL`, `Installed`, `Inside_Admin`) VALUES ('NETCAT_MODULE_CACHE', 'cache', 'NETCAT_MODULE_CACHE_DESCRIPTION', 'DEBUG_MODE=0\nEFFICIENCY_LOW=0.2\nEFFICIENCY_MID=0.7\nDEFAULT_LIFETIME=60\n', '', '/settings/modules/cache/', 1, 1);
-- update catalogue
UPDATE `Catalogue` SET `Cache_Access_ID` = 2, `Cache_Lifetime` = 60;