<?php
/* $Id: nc_catalogue.class.php 2824 2009-02-12 10:59:27Z vadim $ */

class nc_Catalogue extends nc_Essence {
  
  protected $core;
  protected $db;
  
  /**
   * Constructor function
   */
  public function __construct () {
    // load parent constructor
    parent::__construct();
    
    // system superior object
    $this->core = nc_Core::getObject();
    // system db object
    if ( is_object($this->core->db) ) $this->db = $this->core->db;
    
  }
  
  /**
   * Get catalogue data by the hostname
   *
   * @param string $host
   * @param bool use returned value as current catalogue data
   * @param bool reset stored data in the static variable
   *
   * @return catalogue data associative array
   */
  public function get_by_host_name ($host, $current = false, $reset = false) {
    // call as static
    static $storage = array();
    
    // check inited object
    if ( empty($storage[$host]) || $reset ) {
      // init object
      $storage[$host] = $this->db->get_row("(SELECT * FROM `Catalogue`
        WHERE Domain = '".$this->db->escape($host)."'
        OR (CONCAT('|', REPLACE(Mirrors, '\\n', '|')) LIKE '%|".$this->db->escape($host)."%') LIMIT 1)
        UNION (SELECT * FROM `Catalogue` ORDER BY `Checked` = 1, `Priority`, `Catalogue_ID` LIMIT 1)
        LIMIT 1", ARRAY_A);
      
      // processing system fields
      $storage[$host] = $this->convert_system_vars($storage[$host]);
      
      if ($current) {
        // set current catalogue data
        $this->current = $storage[$host];
      }
    }
    
    // return result
    return $storage[$host];
  }
  
  function inherit () {
    // for compatibillity
    return $this->get_current();
  }
  
}


?>