<?php
/* $Id: nc_template.class.php 3143 2009-04-17 13:02:22Z vadim $ */

class nc_Template extends nc_Essence {
  
  protected $core;
  protected $db;
  
  /**
   * Constructor function
   */  
  public function __construct () {
    // load parent constructor
    parent::__construct();
    
    // system superior object
    $this->core = nc_Core::getObject();
    // system db object
    if ( is_object($this->core->db) ) $this->db = $this->core->db;
    
  }
  
  protected function inherit () {
    global $perm, $AUTH_USER_ID, $templatePreview;

    $template_env = $this->get_current();

    $template_env = $this->convert_system_vars($template_env);
    
    //     
    $magic_gpc = get_magic_quotes_gpc();
    if ( $template_env["Template_ID"] == $templatePreview && !empty($_SESSION["PreviewTemplate"][$templatePreview]) ) {
      foreach($_SESSION["PreviewTemplate"][$templatePreview] as $key => $value) {
        $template_env[$key] = $magic_gpc ? stripslashes($value) : $value;
      }
    }

    $parent_template = $template_env["Parent_Template_ID"];
    while ($parent_template) {
      
      $parent_template_env = $this->get_by_id($parent_template);
    
      //      ,      .
      if ( $parent_template_env["Template_ID"]==$templatePreview && !empty($_SESSION["PreviewTemplate"][$templatePreview]) ) {
        foreach($_SESSION["PreviewTemplate"][$templatePreview] as $key => $value) {
          $parent_template_env[$key] = $magic_gpc ? stripslashes($value) : $value;
        }
      }

      $parent_template = $template_env["Parent_Template_ID"];

      if (!$template_env["Header"]) {
        $template_env["Header"] = $parent_template_env["Header"];
      }
      else {
        if ($parent_template_env["Header"]) { $template_env["Header"] = str_replace ("%Header", $parent_template_env["Header"], $template_env["Header"]); }
      }
      if (!$template_env["Footer"]) {
        $template_env["Footer"] = $parent_template_env["Footer"];
      }
      else {
        if ($parent_template_env["Footer"]) { $template_env["Footer"] = str_replace ("%Footer", $parent_template_env["Footer"], $template_env["Footer"]); }
      }
      $template_env["Settings"] = $parent_template_env["Settings"].$template_env["Settings"];
      
      $parent_template_env = $this->convert_system_vars($parent_template_env);
      
      $template_env = InheritSystemFields($this->essence, $parent_template_env, $template_env);
      $parent_template = $parent_template_env["Parent_Template_ID"];
    }

    // load system table fields
    $table_fields = $this->core->get_system_table_fields($this->essence);
    // count
    $counted_fileds = count( $table_fields );
    
    for ($i=0; $i < $counted_fileds; $i++) {
      $template_env["Header"] = str_replace("%".$table_fields[$i]['name'], $template_env[$table_fields[$i]['name']], $template_env["Header"]);
      $template_env["Footer"] = str_replace("%".$table_fields[$i]['name'], $template_env[$table_fields[$i]['name']], $template_env["Footer"]);
    }
    
    // add system CSS styles in admin mode
    if ($this->core->admin_mode && !$this->core->inside_admin && $template_env["Header"]) {
      // addon css and js
      $template_admin_css = "<link type='text/css' rel='stylesheet' href='".$this->core->ADMIN_TEMPLATE."css/admin_pages.css'/>\r\n";
      $template_admin_css .= "<script type='text/javascript' src='".$this->core->ADMIN_PATH."js/package.js'></script>\r\n";
      // pattern and replacement for preg_replace()
      switch (true) {
        case preg_match("/\<\s*?\/head\s*?\>/im", $template_env["Header"]):
          $preg_pattern = "/(\<\s*?\/head\s*?\>){1}/im";
          $preg_replacement = $template_admin_css."\n\$1";
        break;
        case preg_match("/\<\s*?html\s*?\>/im", $template_env["Header"]):
          $preg_pattern = "/(\<\s*?html\s*?\>){1}/im";
          $preg_replacement = "\$1\n<head>".$template_admin_css."</head>";
        break;
        default:
          $preg_pattern = "/(\A)/im";
          $preg_replacement = $template_admin_css."\n\$1";
      }
      $template_env["Header"] = preg_replace($preg_pattern, $preg_replacement, $template_env["Header"]);
    }
    
    // $_GET['rand'] -        ,      
    //       QuickBar
    //   AUTH_USER_ID,    
    if ( $this->core->AUTHORIZATION_TYPE!= 'http' ) {
      if ($this->core->get_settings('QuickBar') && !$_GET['rand'] && ($AUTH_USER_ID || Authorize()) && is_object($perm) && $perm->isSupervisor() ) {
        $cookie_domain = ($this->core->modules->get_vars('auth', 'COOKIES_WITH_SUBDOMAIN') ? str_replace("www.", "", $this->core->HTTP_HOST) : NULL);
        if ($this->core->input->fetch_cookie('QUICK_BAR_CLOSED')==0 || $this->core->input->fetch_cookie('QUICK_BAR_CLOSED')==-1) {
          require_once ($this->core->INCLUDE_FOLDER."quickbar.inc.php");
          $template_env["Header"] = nc_quickbar_in_template_header($template_env["Header"]);
          setcookie("QUICK_BAR_CLOSED", -1, time() + $this->core->ADMIN_AUTHTIME, "/", $cookie_domain);
        }
        else {
          // refresh cookie expiration
          setcookie("QUICK_BAR_CLOSED", 1, time() + $this->core->ADMIN_AUTHTIME, "/", $cookie_domain);
        }
      }
    }

    return $template_env;
  }
  
}

?>