<?php
/* $Id: nc_lang.class.php 2909 2009-02-19 16:27:10Z vadim $ */

class nc_Lang extends nc_System {
  
  protected $core;
  protected $langtable;
  
  public function __construct ($core) {
    // load parent constructor
    parent::__construct();
    
    // system superior object
    if ( get_class($core)=="nc_Core" ) $this->core = $core;
    
    $this->langtable = array(
      'af' => 'Afrikaans',
      'sq' => 'Albanian',
      'ar' => 'Arabic',
      'hy' => 'Armenian',
      'as' => 'Assamese',
      'az' => 'Azeri',
      'eu' => 'Basque',
      'be' => 'Belarusian',
      'bn' => 'Bengali',
      'bg' => 'Bulgarian',
      'ca' => 'Catalan',
      'zh' => 'Chinese',
      'hr' => 'Croatian',
      'cs' => 'Chech',
      'da' => 'Danish',
      'div' => 'Divehi',
      'nl' => 'Dutch',
      'en' => 'English',
      'et' => 'Estonian',
      'fo' => 'Faeroese',
      'fa' => 'Farsi',
      'fi' => 'Finnish',
      'fr' => 'French',
      'mk' => 'FYRO Macedonian',
      'gd' => 'Gaelic',
      'ka' => 'Georgian',
      'de' => 'German',
      'el' => 'Greek',
      'gu' => 'Gujarati',
      'he' => 'Hebrew',
      'hi' => 'Hindi',
      'hu' => 'Hungarian',
      'is' => 'Icelandic',
      'id' => 'Indonesian',
      'it' => 'Italian',
      'ja' => 'Japanese',
      'kn' => 'Kannada',
      'kk' => 'Kazakh',
      'kok' => 'Konkani',
      'ko' => 'Korean',
      'kz' => 'Kyrgyz',
      'lv' => 'Latvian',
      'lt' => 'Lithuanian',
      'ms' => 'Malay',
      'ml' => 'Malayalam',
      'mt' => 'Maltese',
      'mr' => 'Marathi',
      'mn' => 'Mongolian',
      'ne' => 'Nepali',
      'no' => 'Norwegian',
      'or' => 'Oriya',
      'pl' => 'Polish',
      'pt' => 'Portuguese',
      'pa' => 'Punjabi',
      'rm' => 'Rhaeto-Romanic',
      'ro' => 'Romanian',
      'ru' => 'Russian',
      'sa' => 'Sanskrit',
      'sr' => 'Serbian',
      'sk' => 'Slovak',
      'ls' => 'Slovenian',
      'sb' => 'Sorbian',
      'es' => 'Spanish',
      'sx' => 'Sutu',
      'sw' => 'Swahili',
      'sv' => 'Swedish',
      'syr' => 'Syriac',
      'ta' => 'Tamil',
      'tt' => 'Tatar',
      'te' => 'Telugu',
      'th' => 'Thai',
      'ts' => 'Tsonga',
      'tn' => 'Tswana',
      'tr' => 'Turkish',
      'uk' => 'Ukrainian',
      'ur' => 'Urdu',
      'uz' => 'Uzbek',
      'vi' => 'Vietnamese',
      'xh' => 'Xhosa',
      'yi' => 'Yiddish',
      'zu' => 'Zulu'
    );
  }
  
  public function full_from_acronym ($lang) {
  	
    if ( in_array($lang, $this->langtable) ) return $this->langtable[$lang];
    
  }
  
  public function acronym_from_full ($lang) {

    foreach ($this->langtable as $key => $value) {
      if ($value==$lang) return $key;
    }
    
  }

}

?>