<?php
/* $Id: nc_utf8.class.php 2748 2009-02-03 18:16:28Z vadim $ */

class nc_Utf8 extends nc_System {

  protected $core;
  protected $UTFConverter;
  
  public function __construct ($core) {
    // load parent constructor
    parent::__construct();
    
    global $UTFConverter;
    
    // system superior object
    if ( get_class($core)=="nc_Core" ) $this->core = $core;
    
    $this->UTFConverter = $UTFConverter;
  }
  
  // cp1251 to utf
  public function win2utf ($str) {
    if ( extension_loaded("mbstring") ) {
      return mb_convert_encoding($str, "UTF-8", "cp1251");
    }
    if ( extension_loaded("iconv") ) {
      return iconv("cp1251", "UTF-8", $str);
    }

    if (!$this->UTFConverter)
    {
      require_once($this->core->INCLUDE_FOLDER."lib/utf8/utf8.class.php");
      $this->UTFConverter = new utf8(CP1251);
    }
    
    return $this->UTFConverter->strToUtf8($str);
  }


  // utf to cp1251
  public function utf2win ($str) {
    if ( extension_loaded("mbstring") ) {
      return mb_convert_encoding($str, "cp1251", "UTF-8");
    }
    if ( extension_loaded("iconv") ) {
      return iconv("UTF-8", "cp1251", $str);
    }

    if (!$this->UTFConverter) {
      require_once($this->core->INCLUDE_FOLDER."lib/utf8/utf8.class.php");
      $this->UTFConverter = new utf8(CP1251);
    }
    
    return $this->UTFConverter->utf8ToStr($str);
  }
  
  public function array_utf2win($input) {
    if (!is_array($input)) {
      return $this->utf2win($input);
    }
    $output = array();

    foreach ($input as $k => $v) {
      $output[ $this->utf2win($k) ] = is_array($v) ? $this->array_utf2win($v) : $this->utf2win($v);
    }

    return $output;
  }

}
?>